<?php

namespace Drupal\telega\Utility;

/**
 * Redis Store Trait.
 */
trait RedisStoreTrait {

  /**
   * Start Cconversation.
   */
  public function startConversation() {
    $conversation = $this->getName();
    return $this->setVal('conversation', $conversation);
  }

  /**
   * Stop conversation.
   */
  public function stopConversation() {
    return $this->setVal('conversation', "");
  }

  /**
   * Set Val to Redis.
   */
  public function setVal(string $name, int|string $val) : string | NULL {
    $root = $this->getRoot();
    if (\Drupal::hasService('redis')) {
      return \Drupal::service('redis')->set("$root:$name", $val);
    }
    return NULL;
  }

  /**
   * Get value From Redis.
   */
  public function getVal(string $name) : string | NULL {
    $root = $this->getRoot();
    if (\Drupal::hasService('redis')) {
      return \Drupal::service('redis')->get("$root:$name");
    }
    return NULL;
  }

  /**
   * Root.
   */
  public function getRoot() : string {
    // $bot_id = $this->telegram->getBotId();
    $bot_name = $this->telegram->getBotUsername();
    $chat_id = $this->getMessage()->getChat()->getId();
    return "\$telega:{$bot_name}:{$chat_id}";
  }

}
